#!/usr/bin/python

from sys             import argv, version
from os              import path, chdir, mkdir
from shutil          import copyfile

from wxPython.wx     import *
from wxPython.help   import *

from DlgMain.DlgMain import DlgMain
from ConfigFile      import Config

assert version >= '2', "Install Python 2.0 or greater"

###########################################################################################################
###########################################################################################################

class App(wxApp):

###########################################################################################################

    def __init__(self):
        wxApp.__init__(self)

###########################################################################################################

    def OnInit(self):
        wxHelpProvider_Set( wxSimpleHelpProvider() )
        Dlg = DlgMain()
        Dlg.Show(true)
        Dlg.Raise()
        return true

###########################################################################################################
###########################################################################################################

if __name__ == '__main__':
    # Change to the directory of BT++
    chdir(
     path.abspath(
             path.dirname(argv[0])
                 )
         )
    
    try: mkdir(Config.Get('Paths', 'Incoming')) 
    except: pass
    try: mkdir(Config.Get('Paths', 'Torrent'))
    except: pass
    try: mkdir(Config.Get('Paths', 'History'))
    except: pass
    try: mkdir(Config.Get('Paths', 'Temp'))
    except: pass
    
    # Copy torrent file
    if len(argv) > 1:
        try:
            copyfile(argv[1], path.join(Config.Get('Paths', 'Torrent'), path.split(argv[1])[1]))
        except:
            pass
    
    wxInitAllImageHandlers()
    
    checker = wxSingleInstanceChecker( "BitTorrent++ - " + wxGetUserId() )
    if checker.IsAnotherRunning() == false:
        app = App()
        app.MainLoop()
